/* Stupid "buy/sell grain" game */
#include <ctype.h>
#include <curses.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>

unsigned long grain = 15000, gold = 15000, acres = 1500, year = 1000;
unsigned long people = 750, feed = 19, landprice = 100, grainprice = 15;
unsigned long mills = 0, fabric = 5, taxes = 0, fabricprice = 500;

#define CTRL(c) ((c) & 0x1F)

#define rnd(n) ((n)<2?0:rand()%(n))
#define die(n) ((n)<2?1:rand()%(n)+1)
#define max(x,y) ((x) < (y) ? (y) : (x))
#define min(x,y) ((x) > (y) ? (y) : (x))

/* we use these locally */
int vgetc(void), ivgetc(void), ynq(void), getnum(void);
void show(void), see_ya_dude(void);

int
vgetc(void) {
	int c;
	echo();
	c = getch();
	noecho();
	return c;
}

int
ivgetc(void) {
	int c;
	c = getch();
	return c;
}

int
ynq(void) {
	int c;
	do {
		c = getch();
		if (c == 0x1B)
			c = 'q';
		c = tolower(c);
	} while (!strchr("ynq", c));
	if (c == 'y')
		return 0;
	if (c == 'n')
		return 1;
	return -1;
}

int
getnum(void) {
	int c;
	int n = 0;
	do {
		c = getch();
		if (isdigit(c)) {
			putchar(c);
			fflush(stdout);
			n *= 10;
			n += c - '0';
		} else if (c == '\n') {
			break;
		} else {
			putchar('\a');
			fflush(stdout);
		}
	} while(1);
	return n;
}

void
show(void) {
	printw("\n\nYear: %-4d  Food stores: %-8d   Land: %d acres     Population: %d\nTreasury: %-7d   Taxes: %d%% Mills: %d    Fabrics: %d bolts\n",
	  year, grain, acres, people, gold, taxes, mills, fabric);
}

void
see_ya_dude(void) {
	clear();refresh();
	show();
	printw("Really quit? ");refresh();
	if(ynq() != 1) {
    printw("\nNot bad, for a beginner. ;-)\n");refresh();
	  exit(0);
	}
}

int
main(int argc, char *argv[]) {
  int c = '\0', i;
	unsigned long tmp = 0,tmp2 = 0;

	initscr();

	srand((long) time((void *)0));
	cbreak(); noecho();

	printw("%c",CTRL('L'));refresh();
	printw("Would you like instructions? ");refresh(); {
	  switch(ynq()) {
		  case 0:
		    printw("Yes.\nTough - there aren't any.\n");refresh();
				printw("<Hit any key to continue>");refresh();
				c = ivgetc();
			  break;
			case 1:
			  printw("No.\n");refresh(); break;
			case -1:
			  printw("Quit.\n"); exit(0);refresh();
		}
	}
	do {
	  printw("%c",CTRL('L'));refresh();
	  switch(die(8)) {
		  case 1: fabricprice -=3; break;
		  case 2: fabricprice -=2; break;
			case 3: case 4: --fabricprice; break;
			case 5: case 6: ++fabricprice; break;
		  case 7: fabricprice +=2; break;
		  case 8: fabricprice +=3; break;
		}
	  switch(die(8)) {
		  case 1: landprice -=3; break;
		  case 2: landprice -=2; break;
			case 3: case 4: --landprice; break;
			case 5: case 6: ++landprice; break;
		  case 7: landprice +=2; break;
		  case 8: landprice +=3; break;
		}
	  switch(die(6)) {
		  case 1: grainprice -=2; break;
			case 2: case 3: --grainprice; break;
			case 4: case 5: ++grainprice; break;
		  case 6: grainprice +=2; break;
		}
		if(taxes < 2) { --grainprice; --landprice; ++fabricprice; }
		else if(taxes > 7) { ++grainprice; ++landprice; --fabricprice; }
		if(taxes > 12) { grainprice += 2; landprice += 2; fabricprice -= 5; }

		if(grain > people * 20) grainprice -= 2;
		if(acres > people) landprice -= 2;
		if(acres < people) landprice += 2;
		if(grain < people * 15) grainprice += 2;
		if(mills > 10) landprice += 2;

		if(fabricprice < 485) fabricprice = 485;
		if(fabricprice > 550) fabricprice = 550;
		if(landprice < 80) landprice = 80;
		if(landprice > 120) landprice = 120;
		if(grainprice < 10) grainprice = 10;
		if(grainprice > 23) grainprice = 23;

		clear();refresh();
		show();
		FABRIC:
		if(fabric > 0) {
  		printw("\nCurrent cost for a bolt of fabric is %d gold. Sell? ",fabricprice);refresh();
			if(!ynq()) {
			  printw("Yes.\nHow many bolts? ");refresh();
				c = getnum();
				if(!c) {
				  if(fabric) {
				    printw("\nAssuming %d bolts...\n",fabric);refresh();
				    gold += fabricprice * fabric;
				    fabric = 0;
				  } else
				    printw("None.\n");refresh();
				} else if(c > fabric) {
				  printw("\nYou don't have that many bolts! (short by %d)\n",c - fabric);refresh();
				  goto FABRIC;
				} else {
				  gold += c * fabricprice;
				  fabric -= c;
				  printw("\n");refresh();
				}
			}
	  }
		LAND:
		printw("\nCurrent asking price on land is %d gold. Buy? ",landprice);refresh();
		switch(ynq()) {
		  case 0:
			  printw("Yes.\nHow many acres? ");refresh();
				c = getnum();
				if(!c) {
				  if(acres < people) {
				    c = min((int) (gold / landprice), people - acres);
				    printw("\nAssuming %d acres.\n",c);refresh();
				    gold -= c * landprice;
				    acres += c;
				  }
				  printw("\n");refresh();
				} else if(c * landprice > gold) {
				  printw("\nYou don't have that much money! (short by %d)\n",
					  (c * landprice) - gold);
					goto LAND;
				} else {
				  gold -= c * landprice;
					acres += c;
					printw("\n");refresh();
				}
			  break;
			case 1:
			  printw("No.\nSell? ");refresh();
				switch(ynq()) {
				  case 0:
					  printw("Yes.\nHow many acres? ");refresh();
				    c = getnum();
				    if(!c) {
				      if(acres > people) {
				        c = acres - people;
				        printw("\nAssuming %d acres.\n",c);refresh();
				        gold += c * landprice;
				        acres -= c;
				      }
				      printw("\n");refresh();
				    } else if(c > acres) {
				      printw("\nYou don't have that many acres! (short by %d)\n",
					      c - acres);
					    goto LAND;
				    } else {
				      gold += c * landprice;
					    acres -= c;
					    printw("\n");refresh();
				    }
					  break;
          case 1:
				  case -1:
					  printw("\n");refresh();
					  break;
				}
			  break;
			case -1:
			  printw("\n");refresh();
				break;
		}
		GRAIN:
		printw("Current asking price on grain is %d gold per bushel. Buy? ",grainprice);refresh();
		switch(ynq()) {
		  case 0:
			  printw("Yes.\nHow many bushels? ");refresh();
				c = getnum();
				if(!c) {
				  if(grain < people * 20) {
				    c = min((people * 20) - grain, gold / grainprice);
				    printw("\nAssuming %d bushels.");refresh();
				    grain += c;
				    gold -= c * grainprice;
				  }
				  printw("\n");refresh();
				} else if(c * grainprice > gold) {
				  printw("\nYou don't have that much money! (short by %d)\n",
					  (c * grainprice) - gold);
					goto GRAIN;
				} else {
				  gold -= c * grainprice;
					grain += c;
					printw("\n");refresh();
				}
			  break;
			case 1:
			  printw("No.\nSell? ");refresh();
				switch(ynq()) {
				  case 0:
					  printw("Yes.\nHow many bushels? ");refresh();
				    c = getnum();
				    if(!c) {
				      if(grain > people * 20) {
				        c = grain - (people * 20);
				        printw("\nAssuming %d bushels.",c);refresh();
				        grain -= c;
				        gold += c * grainprice;
				      }
				      printw("\n");refresh();
				    } else if(c > grain) {
				      printw("\nYou don't have that much grain! (short by %d)\n",
					      c - grain);
					    goto GRAIN;
				    } else {
				      gold += c * grainprice;
					    grain -= c;
					    printw("\n");refresh();
				    }
					  break;
          case 1:
				  case -1:
					  printw("\n");refresh();
					  break;
				}
			  break;
			case -1:
			  printw("\n");refresh();
				break;
		}
		FEED:
		printw("\nYou have %d people.\nHow many bushels each will you give them? ", people);refresh();
		c = getnum();
		if(c == 0) {
		  tmp = (grain / people) - 3;
      if(tmp > 17) tmp = 17;
			if(tmp < 12) {
			  printw("\nYou have too little food to plant crops and feed your people.\nDo you wish to feed your people? ");refresh();
				if(!ynq()) goto FEED;
			} else {
			  c = tmp;
			  printw("\nAssuming %d bushels each...",tmp);refresh();
			}
	  }
		if(c  * people > grain) {
		  printw("\nYou don't have that much! (You have %d bushels per person)",grain / people);refresh();
			goto FEED;
		}
		feed = (feed + c) / 2;
		grain -= (c * people);
		if(feed < 10) {
		  printw("\nCareful... Your people may starve!");refresh();
		} else if (feed > 20) {
		  printw("\nYour people erect a public monument to your generosity!");refresh();
			gold += ((die(5) + 5) * gold) / 100;
			/* 6-10% increase in gold! */
		}
    PLANTING:
		printw("\nHow many acres to plant? ");refresh();
    c = getnum();
		if(c == 0) {
		  tmp = min(grain/3,min(people,acres));
		  printw("\nAssuming %d acres (maximum)...",tmp);refresh();
			c = tmp;
		}
		if(c < 0)
		  goto PLANTING;
		if(c > acres) {
		  printw("\nYou don't have that much land! (You have %d acres)",acres);refresh();
			goto PLANTING;
		} else if(c * 3 > grain) {
		  printw("\nYou don't have enough grain! (You have %d bushels)",grain);refresh();
			goto PLANTING;
		} else if(c > people) {
		  printw("\nYou don't have enough people! (You have %d people)",people);refresh();
			goto PLANTING;
		} else {
		  grain -= c * 3;
      tmp = die(30) + 185;
			if(c < (acres * 4) / 5)
			  tmp += 20; /* bonus for underplanting. */
			if(c < (people * 4) / 5)
			  tmp += 30; /* bonus for rested workers. */
			tmp += (10 * (feed - 15));
			tmp -= (5 * (taxes - 7));
			if(!taxes) tmp += 20;
			if(feed <= 12)
			  tmp -= 30;
			if(feed >= 17)
			  tmp += 50;
			if(!rnd(10) && year > 1010) {
			  tmp -= 70;
				printw("\nThere is a massive drought! Your farms do badly this year.");refresh();
			}
			tmp = max(0,tmp);
			tmp2 = (tmp * c) / 10;
			grain += tmp2;
			printw("\nYour average yield is %d.%d bushels per acre.\nYour total yield is %d bushels.",
			  tmp / 10, tmp % 10, tmp2);
		}

		if(feed < 10) {
		  tmp = (people * feed + rnd(10)) / 10;
			printw("\n%d of your people starve.",people - tmp);refresh();
			people = tmp;
		}
		tmp = rnd(10) + 5 + (feed<=12?-4:(feed>=17?4:0))+(taxes<=3?3:(taxes>12?-8:0));
		tmp2 = (people * tmp) / 100;

    if(tmp)
		  printw("\n%d people %s your community.",abs(tmp2), (tmp>0?"join":"leave"));refresh();
		people += tmp2;

		tmp = rnd(5) + 3 + (feed<=12?2:(feed>=17?-2:0));
		tmp2 = (people * tmp) / 100;
    if(tmp)
		  printw("\n%d people from your community die of natural causes.",(tmp>0?tmp2:-tmp2), (tmp>0?"join":"leave"));refresh();
    people -= tmp2;

		printw("\nYour total grain at the end of the year is %d bushels.",grain);refresh();
		tmp = die(6) + 3;
		if(!taxes) --tmp;
		if(feed > 15) --tmp;
		if(taxes < 5) --tmp;
		if(taxes > 8) ++tmp;
		if(feed <= 12) ++tmp;
		printw("\nYou lose about %d%% of your grain to the weather and rats.",tmp);refresh();
		grain = (grain * (100 - tmp)) /100;
		grain = max(0,grain);

    TAXES:
    printw("\nWhat rate would you like to tax your people at for the coming year? ");refresh();
		c = getnum();
		if(c > 20) {
		  printw("\nThe people won't stand for it...");refresh();
			goto TAXES;
		} else
		  taxes = c;
		tmp2 = (people * taxes) / 10;
		gold += tmp2;

		clear();refresh();
		show();
		if(taxes)
		  printw("\nAnnual tax revenues were %d gold.",tmp2);refresh();

		if(year > 1010) { /* short safe period... */
		  switch(rnd(50)) {
		    case 0:
			    tmp = min(rnd(250)+250,(acres / 4));
				  tmp2 = min(rnd(50)+100,(people / 4));
			    printw("\nHuns pillage, taking %d acres of your land, and killing %d people!!",tmp,tmp2);refresh();
				  acres -= tmp; people -= tmp2;
				  break;
			  case 1:
			    printw("\nA star is observed over your city, and wise men come, bringing gold.");refresh();
				  gold = (gold * (110 + rnd(10))) / 100;
				  break;
			  case 2:
			    tmp = ((rnd(10) + 5) * grain) / 100;
				  printw("\nRat lovers convention in your capital city - rats eat much of your grain.");refresh();
				  grain -= tmp;
				  break;
			  case 3:
			    tmp = ((rnd(5) + 5) * grain) / 100;
				  printw("\nFamine! Your people raid the granaries for more food.");refresh();
				  grain -= tmp;
				  break;
			  case 4:
			    tmp = ((rnd(10) + 20) * people) / 100;
			    printw("\nPlague strikes, killing %d people!",tmp);refresh();
				  people -= tmp;
				  break;
			  case 5:
			    tmp = rnd(50) + 250;
				  tmp2 = rnd(250) + 1500;
				  printw("\nA neighboring dukedom collapses, and their people migrate to you.");refresh();
				  printw("\nLuckily, they bring a small amount of food with them.");refresh();
				  acres += tmp;
				  people += tmp2;
				  grain += (tmp2 * (5 + die(5)));
				  break;
			  case 6:
			    printw("\nA rebellion strikes! Much of your country is taken by rebels!");refresh();
				  tmp = rnd(10) + 5;
				  acres -= (acres * (tmp + 5)) / 100;
				  people -= (people * tmp) / 100;
				  break;
			  case 7:
				  printw("\nManna rains from the heavens!");refresh();
				  tmp = (die(3) + 3) * people;
				  grain += tmp;
				case 8:
				  if(mills) {
				    printw("\nA mysterious bolt of thunder destroys a woolen mill!");refresh();
				    --mills;
				  }
				  break;
				case 9:
				  /* economic upheaval... */
				  printw("\nA mysterious sign portends great change in the marketplace.");refresh();
				  grainprice = 15 + (15 - grainprice);
				  landprice = 100 + (100 - landprice);
				  fabricprice = 500 + (500 - fabricprice);
				  break;
			  default:
			    break;
		  }
		}

    if(gold >= 100000) {
		  printw("\nDo you wish to construct any woolen mills (cost 100000 gold)? ");refresh();
		  if(!ynq()) {
		    MILLS:
		    printw("\nHow many? ");refresh();
		    tmp = getnum();
		    if(!tmp) {
		      tmp = (int) gold / 100000;
		      printw("\nAssuming %d mills... (maximum)",tmp);refresh();
		    }
		    if((tmp * 100000) > gold) {
		      printw("\nError: Insufficient gold.");refresh();
		      goto MILLS;
		    } else {
		      mills += tmp;
		      gold -= (tmp * 100000);
			    printw("\nThere is rejoicing in the streets!");refresh();
			  }
		  }
		}

    if(mills > 0) {
		  tmp2 = 0;
		  for(i=0;i<mills;++i) {
		    tmp = die(3) + 1;
		    if(feed <= 12) --tmp;
		    if(taxes >= 8) --tmp;
			  if(!taxes) ++tmp;
		    if(taxes <= 3) ++tmp;
		    if(feed >= 17) ++tmp;
				tmp2 += tmp;
			}
		  printw("\nYour annual take from woolen mills is %d bolts of fabric.", tmp2);refresh();
			fabric += tmp2;
		}

		if(people == 0 || acres == 0) {
		  printw("\nYour little kingdom is no more!");refresh();
			see_ya_dude();
		}
		if(fabric >= 10000 && people >= 20000 && acres >= 50000) {
		  clear();refresh();
		  printw("\nYou have enough fabric to make more than ten thousand wedding dresses!");refresh();
			printw("\nYou have enough women to wear the dresses!");refresh();
			printw("\nYou have enough land to give them all homes!");refresh();
		  printw("\nY*O*U   W*O*N   ! ! !\nYour final status:");refresh();
			show();
			exit(0);
		}

		if(gold < 100) { printw("\nWarning: Low on funds.");refresh(); }
		if(grain < (people * 16)) { printw("\nWarning: Low on food.");refresh(); }
		if(acres < people) { printw("\nWarning: Low on land.");refresh(); }
		printw("\nHit any key to continue, or 'q' to quit.");refresh();
		c = ivgetc();
		if(c == 'q' || c == 'Q')
		  see_ya_dude();
		++year;

	} while(1);
	nocbreak(); echo();
	endwin();
  return 0;
}
