#include <stdlib.h>

#undef malloc
#undef free
#undef realloc
#undef calloc

#ifdef MDB
#define malloc(x) (*mmalloc)(__FILE__, __LINE__, (x))
#define free(x) (*mfree)(__FILE__, __LINE__, (x))
#define realloc(x, y) (*mrealloc)(__FILE__, __LINE__, (x), (y))
#define calloc(x, y) (*mcalloc)(__FILE__, __LINE__, (x), (y))
#else
#define malloc(x) ((x) ? malloc(x) : (void *) 0)
#define calloc(x, y) (calloc((x), (y)))
#define free(x) ((void)((x) && (free(x),0)))
#define realloc(x, y) ((x) ? ((y) ? realloc((x), (y)) : (free((x)), (void *) 0)) : malloc((y)))
#endif

extern void * (*mmalloc)(char *, int, size_t);
extern void * (*mcalloc)(char *, int, size_t, size_t);
extern void * (*mrealloc)(char *, int, void *, size_t);
extern void (*mfree)(char *, int, void *);

extern void mdb_on(void);
extern void mdb_off(void);
